/* preferences.h
 * Copyright (C) 2001 The University of Newcastle upon Tyne
 *
 * Written by Paul Coates (Paul.Coates@ncl.ac.uk)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef PREFS_H
#define PREFS_H 1

#include <gtk/gtk.h>
#include <gnome-xml/tree.h>
#include <gnome-xml/parser.h>

class Main;
class Preferences
{
	public:
		Preferences(Main *m);
		~Preferences();

		void build_sidebar();
		GtkWidget *sidebar_button(char *label);
		void sidebar_icon(GtkWidget *w, char *label, char **icon, int pg);
		void sidebar_pad(GtkWidget *w);
		void sidebar_button_pressed(GtkWidget *w);
		void sidebar_icon_pressed(GtkWidget *w);
		void show();
		void hide();


		void select_community(int r);
		void unselect_community();
		void add_community();
		void del_community();

		void load();
		void save();
		void load_settings();
		void save_settings();
		void set_config_from_community();
		void set_community_from_config();
		void set_graph_from_config();

		Main *main;
		int community_row;
		int state;

		GtkWidget *window;
		GtkWidget *button1;
		GtkWidget *button2;
		GtkWidget *sidebar;
		GtkWidget *notebook;
		GtkWidget *current_panel;
		GSList *button_group;

		GtkWidget *entry9;
		GtkWidget *entry10;
		GtkWidget *entry11;
		GtkWidget *entry13;
		GtkWidget *clist2;
		GtkWidget *clist3;
		GtkWidget *clist4;
		GtkWidget *entry5;
		GtkWidget *button7;
		GtkWidget *button8;
};

gchar *get_community_list_string();
void set_config_from_editable(GtkWidget *w, gchar *config);
void set_editable_from_config(GtkWidget *w, gchar *config);
gchar *user_file(gchar *fname);

#endif

