#ifndef IPADDRESS_H
#define IPADDRESS_H 1

class IPAddress
{
	public:
		IPAddress();
		~IPAddress();
		IPAddress(IPAddress &orig);

		void operator = (const IPAddress &orig);

		void empty();
		void print();
		unsigned long getul();
		void setul(unsigned long l);
		char *getstring();
		void setstring(char *str);
		void setpartialstring(char *str);
		void setafinet(char *str);
		char *getuls();
		void setuls(char *buf);
		void set(IPAddress pi);
		int zero();
		int compare(IPAddress pi);
		int compare(char *str);
		int in_range(IPAddress s1, IPAddress s2);
		int in_range(unsigned long s1, unsigned long s2);
		int in_range(char *str1, char *str2);
		void make_ip(IPAddress subnet, int mask, int offset);
		void make_ip(char *subnet, int mask, int offset);
		void make_subnet(IPAddress ip, int mask);
		void make_subnet(char *str, int mask);
		void make_broadcast(IPAddress s1, int mask);
		void make_mask(int mask);
		int mask_value();
		int valid_mask();

		unsigned long ip;
};

int mask_power(int pwr);
int overlap(IPAddress ip1, int m1, IPAddress ip2, int m2);

#endif

