#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include "process.h"

Process::Process()
{
	tid = 0;
}

Process::~Process()
{
}

int Process::create(int t)
{
	if (socketpair(AF_UNIX, SOCK_STREAM, 0, fd)<0)
		return 0;

	type = t;

	pid = fork();
	if (pid == -1)
	{
		return 0;
	}else
	if (pid == 0)
	{
		close(fd[1]);
		child();
		close(fd[0]);
		_exit(0);
	}

	fcntl(fd[1], F_SETFL, O_NONBLOCK);

	return 1;
}

void Process::child()
{
	char str[256];
	char buf[BUFSIZE];
	char cmnd[BUFSIZE];
	int i, quit=0;

	fcntl(fd[0], F_SETFL, O_NONBLOCK);

	while(!quit)
	{
		i = read(fd[0], buf, BUFSIZE);
		if (i>0)
		{
			sscanf(buf, "%[^ ] %d %[^\n]", cmnd, &type, param);
			if (type==1)	// discover
			{
				sprintf(str, "nomad-topology %s", param);
//printf("%s\n", str);
				system(str);
				strcpy(cmnd, "DONE");
			}else
			if (type==2)	// alive
			{
				sprintf(str, "nomad-alive %s", param);
//printf("%s\n", str);
				system(str);
				strcpy(cmnd, "DONE");
			}else
			if (type==0)
			{
				quit = 1;
				strcpy(cmnd, "DONE");
			}else
				strcpy(cmnd, "FAILED");
			sprintf(buf, "%s %d %s", cmnd, type, param);
			write(fd[0], buf, strlen(buf)+1);
		}
		usleep(2000000);
	}
}

void Process::send(char *str)
{
	char buf[BUFSIZE];
	sprintf(buf, "%s %d %s", str, type, param);
	write(fd[1], buf, strlen(buf)+1);
}

int Process::get(char *str)
{
	int i;
	char buf[BUFSIZE];

	i = read(fd[1], buf, BUFSIZE);
	if (i>0)
	{
		sscanf(buf, "%[^ ] %d %[^\n]", buf, &type, param);
		strcpy(str, buf);
		return 1;
	}
	return 0;
}

int Process::check_link()
{
	return (kill(pid, 0));
}

